Program ExemploAbertura;
// Implementao das aes de abertura do Programa "MadeirasRec" com
// a aplicao de Funo Menu de "LibMenu3"
// e implementao de funes auxiliares
// Autor(es): xxxx
// Verso inicial: 26/07/2014           Verso atual: 26/06/2016

uses ModuloCarga, ModuloRelats, LibMenus3, DefGerais;
                                                
const MenuPrinc : ArrayMenu = ('Carregamento', 'Relatrio Mensal', 'Estatstica Anual', 
                               'Utilidades', 'Sobre', 'Fechar', '', '', '', '', '', '', 
                               '', '', '', '', '', '', '', '');

const MenuMes : ArrayMenu = ('Janeiro', 'Fevereiro', 'Maro', 'Abril', 'Maio', 'Junho',
                             'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro',
                             'Dezembro', '-', 'Todos', '', '', '', '', '', '');

const MenuUtil : ArrayMenu = ('Listar BD', 'Exportar BD', 'Importar BD', 
                              '-', 'Trocar BD', '-', 'Opes', '', '', '',                              
                              '', '', '', '', '', '', '', '', '', '');

const TamTextoAbert = 24;
      TextoAbert : array [1..TamTextoAbert] of string =
       (' Este trabalho foi idealizado e realizado em equipe, no contexto didtico',
        ' de duas disciplinas - "Programao de Microcomputadores" e "Algoritmos e',
        ' Programao" com a finalidade de apoiar tanto a fixao de conhecimentos',
        ' bsicos vistos em aula, como a avaliao do aproveitamento dos alunos.',
        '',
        ' O aplicativo "MadeirasRec" destina-se ao controle de fluxo de entrada de',
        ' toras de madeira em uma indstria que trabalha com 3 espcies de rvores',
        ' e recebe carregamentos de diversas origens. Os dados so arquivados para',
        ' o ano civil atual  e so usados para a gerao de relatrios descritivos',
        ' por carregamento e por perodos (mensais e anual).',
        '',
        ' O problema foi modelado a partir de proposta do estudante Getulio Neto e',
        ' a soluo, sob orientao do Prof. Gil Carlos Medeiros, foi desenvolvida',
        ' primeiramente em 2014 pelos seguintes alunos do Centro de Engenharias:',
        ' Getulio Loureno Neto (Eng. Ind. Madeireira),  Cristian Gomes, Guilherme',
        ' dos Santos, Gustavo Calegaro e Tbata Peres (Eng. Civil);  em 2016, por:',
        '',
        '  - Equipe AlgoProg - Fernando, Fernanda e Gabriel (Eng. Ind. Madeireira)',
        '                      e Renan (Eng. de Aut. e Controle);',
        '  - Equipe ProgMicro - Andrey, Antonildes, Gustavo, Kelvin, Leonardo e',
        '                       Lucas (Eng. Ind. Madeireira).',
        '',
        ' A programao, em linguagem Pascal, foi realizada atravs do  compilador',
        ' e do ambiente implementados na ferramenta Pascalzim!.'
        );
        
var Colini, LinIni : integer;
    Direc : DirecaoMenu;
    Func, Mes, Op, OpIni : integer;
    i : integer;
    ModoOper : boolean;
    sAux : string;

  procedure LimpaAreaDeTrabalho;
  begin
    Window(1, 4, 80, 23);
    Textcolor(white);
    Textbackground(black);
    ClrScr;
  end;
  
  procedure MostraNomeBD;
  begin
    Window(1, 24, 80, 25);
    Textbackground(Blue);
    GotoXY(1, 1);
    Textcolor(White);  Write('Banco de Dados: ':79-Length(NomeBD));
    Textcolor(Yellow); Write(NomeBD);
  end;

  procedure EsperaTeclaOuTempo(t : integer);
  begin
    while not Keypressed and (t > 0) do
      begin
      Delay(50);  t := t - 50;    // diviso do tempo pr fazer a verificao do teclado 
      end;
    if Keypressed then Readkey;   // "consome" a tecla que foi pressionada (se foi)
  end;
    
  procedure BoasVindas;
  var i, i1, j : integer;
      t : char;
  begin
    // Escrever rotina que apresenta texto formatado de boas vindas !!!!
    // Eis um exemplo baseado em texto dos alunos:
    LimpaAreaDeTrabalho;
    Window(4, 5, 77, 22);
    Textbackground(Blue);
    clrscr;
    Textbackground(Red);
    GotoXY(1, 1); clreol;
    Textcolor(LightCyan);
    GotoXY(1, 2); for i:=4 to 77 do Write('_');
    Textbackground(Cyan);
    Textcolor(Blue + Blink);       
    GotoXY(23, 1); Write(' Aplicativo MadeirasRec v3.0! ');
    GotoXY(23, 2); Write('   Lanado em Julho de 2016   ');
    Textbackground(Blue);
    
    Textcolor(Yellow + Blink);       
    GotoXY(4, 18);
    Write(' Pressione "Backspace" para reapresentar ou "Enter" para continuar. ');
    
    Window(4, 8, 77, 21);
    Textcolor(Yellow);       
    CursorOff;
    repeat
      Clrscr;
      i := 0;
      GotoXY(1, 13);
      while (i < TamTextoAbert) and not Keypressed do
        begin
        inc(i);
{
        Writeln(TextoAbert[i]);

*** abaixo: soluo alternativa a esta instruo para superar bug 
    no controle de execuo relacionado ao comando "Window" ******
}                                                               //
        if i <= 13 then i1 := 1  else i1 := i - 12;             //
        GoToXY(1, 13-(i-i1));                                   //   
        for j:= i1 to i do                                      //
          Writeln(TextoAbert[j], '':73-Length(TextoAbert[j]) ); //
{****************************************************************}
 
        if i < 12 then Delay(100)
        else if i = 12 then Delay(3000)
        else Delay(1000);
        end;
      repeat t := Readkey; 
      until (t = #13) or (t = #8);
    until t = #13;
    CursorOn;
  end;
  
  procedure Sobre;
  var i, j, k, n : integer;
  begin
    // Escrever rotina que apresenta texto formatado para descrever o programa !!!!
    // Usando o prprio texto de Boas Vindas, por exemplo:

    n := 0;
    for i:=1 to 15 do
      if Length(TextoAbert[i]) > n then
        n := Length(TextoAbert[i]);  
    
    LimpaAreaDeTrabalho;
    cursoroff;
    for j:=n downto 1-3 do
      begin
      if j <= 0 then k := 1-j  else k := 0;
      for i:=1 to 15 do
        begin
        gotoxy(1+k, i+2);
        Write(Copy(TextoAbert[i], j, n));
        end;
      delay(20);
      end;
    EsperaTeclaOuTempo(3000);

    clrscr;
    for j:=1 to n+3 do
      begin
      for i:=1 to 15 do
        begin
        gotoxy(80-j, i+4);
        Write(Copy(TextoAbert[i], 1, j), ' ');
        end;
      delay(20);
      end;
    EsperaTeclaOuTempo(3000);
    cursoron;

    BoasVindas;
  end;

  procedure PegaData(var D, M, A : integer; var Data : string);
  var sAux : string;
  begin
    gotoXY(5, 5); Writeln('Informe a data de operao (dd, mm e aaaa separados):');
    repeat
      gotoXY(1, 7); Write('':80); gotoXY(28, 7); Write('Dia: '); Readln(D);
    until (D > 0) and (D <= 31);
    repeat
      gotoXY(1, 8); Write('':80); gotoXY(28, 8); Write('Ms: '); Readln(M); 
    until (M > 0) and (M <= 12);
    repeat
      gotoXY(1, 9); Write('':80); gotoXY(28, 9); Write('Ano: '); Readln(A); 
    until (A > 2000) and (A <= 2030);

    str(D, Data);
    str(M, sAux);
    Data := Data + '/' + sAux;
    str(A, sAux);
    Data := Data + '/' + sAux;
  end;
           
begin
  Window(1, 1, 80, 25);
  Textcolor(white);
  Textbackground(blue);
  ClrScr;
  Writeln('UFPel-CENG (MADEIRASREC ProgMicro/AlgoProg v3.0)');
  for i:=1 to 80 do Write('_');
  MostraNomeBD;
  
  BoasVindas;
  LimpaAreaDeTrabalho;
  PegaData(dtDia, dtMes, dtAno, DataAtual);
  Str(dtAno, sAux);
  if sAux <> AnoBD then
    begin               // BD passa a ser o nome padro para o Ano indicado
    DefineBD(sAux);
    MostraNomeBD;
    end;

  ModoOper := False;
  OpIni := 1;
  repeat
    Window(1, 3, 80, 4);
    Textbackground(blue);
    mCorTextoMenu := White;
    mCorFundoMenu := Blue;
    mAlturaJanela := 2;
    
    Func := MenuH(MenuPrinc, 6, 1, 1, OpIni); //Menu(Hori, MenuPrinc, 6, 1, 1, OpIni);
    Op := Func;
    Window(1, 4, 80, 23);

    case Func of
      1:  begin
          LimpaAreaDeTrabalho;
          if not ModoOper then
            Mensagem('Aqui vai a chamada do procedimento "RecepcaoDeCarga"', 10, 10, True)
          else
            RecepcaoDeCarga;
          end;
      2:  begin
          mCorTextoMenu := White;
          mCorFundoMenu := Black;
          mAlturaJanela := 20;

          Mes := MenuV(MenuMes, 14, 0, 2, 1); //Menu(Vert, MenuMes, 14, 0, 2, 1);
          LimpaAreaDeTrabalho;
          if (Mes > 0) and (Mes < 13) then
            begin
                       //???????
            Str(Mes, sAux);
            if not ModoOper then
              Mensagem('Aqui vai a chamada do procedimento "Relatrio Mensal" ' +
                       'com parmetro para o ms "' + sAux + '"', 4, 10, True)
            else
              RelEstatMensal(Mes, Mes);     // ou  RelEstatMensal(Mes, 0)
            end
          else if Mes = 14 then
            begin
            if not ModoOper then
              Mensagem('Aqui vo as chamadas sucessivas do procedimento ' +
                       '"Relatrio Mensal" para cada um dos meses', 4, 10, True)
            else
              RelEstatMensal(1, 12);
            end;
          Op := Mes;
          end;
      3:  begin
          LimpaAreaDeTrabalho;
          if not ModoOper then
            Mensagem('Aqui vai a chamada do procedimento "Estatstica Anual"', 10, 10, True)
          else
            RelEstatAnual;
          end;
      4:  begin
          mCorTextoMenu := White;
          mCorFundoMenu := Black;
          mAlturaJanela := 20;

          Op := MenuV(MenuUtil, 7, 0, 2, 5); //Menu(Vert, MenuUtil, 5, 0, 2, 1);
          LimpaAreaDeTrabalho;
          case Op of
            1: ListaBD(NomeBD);
            2: ListaBD(NomeBD);    // ExportaBD = ListaBD  em arquivo 
            3: begin
               ImportaBD;
               MostraNomeBD;
               end;
            5: begin
               TrocaBD;
               MostraNomeBD;
               end;
            7: ModoOper := not ModoOper;
            //...
            end;
          end;
      5:  Sobre;
      6:  Func := -1;
      end;
    if Op > 0 then
      OpIni := 1
    else
      OpIni := 0;
    LimpaAreaDeTrabalho;
  until Func = -1;
  Mensagem('Programa encerrado!', 50, 15, False);
end.
